from __future__ import unicode_literals
import youtube_dl
from youtube_dl.extractor import youtube
import json
import traceback
import threading


def get_info(url):
    
    try:
        ytb = youtube_dl.YoutubeDL({
            "nocheckcertificate": True,
            "Range": "bytes=0-",
            "ratelimit": "0",
            "merge_output_format": True,
            "geo_bypass": True,
            'youtube_include_dash_manifest': True,
        })
        info = ytb.extract_info(url, download=False)
        valid_formats = ["140", "160", "133", "134", "135", "136", "137", "18", "22"]
        valid_exts = ["m4a", "mp4", "mov", "mp3", "m4v"]
        selected_formats = []
        all_formats = []
        for format in info["formats"]:
            all_formats.append(format)
            if format.has_key("ext") and format["ext"] and isinstance(format["ext"], basestring) and format["ext"].lower() in valid_exts:
                selected_formats.append(format)
            #if format.has_key("format_id") and format["format_id"] in valid_formats:
                #selected_formats.append(format)
        #if len(selected_formats) <= 0:
            #selected_formats = all_formats
        thumbnail = ""
        title = ""
        if info.has_key("thumbnail") and isinstance(info["thumbnail"], basestring):
            thumbnail = info["thumbnail"]
        if info.has_key("title") and isinstance(info["title"], basestring):
                   title = info["title"]
        j = json.dumps({
               "formats": selected_formats,
               "thumbnail": thumbnail,
                "title" : title
                       })
        
        #j = json.dumps(info, sort_keys=True, indent=4)
        print "mkmkmkmkmk"
        return j
    #return json.dumps(info, sort_keys=True, indent=4)
    except Exception:
        print "Error extracting info:"
        print(traceback.format_exc())
        raise

def download(url, format, output_file, progress_cb):
    def progress_hook(event):
        progress_cb(json.dumps(event, sort_keys=True, indent=4))

    try:
        print "%s Going to download %s to %s" % (format, url, output_file)
        ytb = youtube_dl.YoutubeDL({
                               "nocheckcertificate": True,
                               "progress_hooks": [progress_hook],
                               "restrictfilenames": True,
                               "nooverwrites": True,
                               "format": format,
                               "outtmpl": unicode(output_file)
                               })

        ytb.download([unicode(url)])
    except Exception:
        print "Error downloading file:"
        print(traceback.format_exc())
        raise

